#include <windows.h>
#include <shlobj.h>
#include <shellapi.h>
#include <string>
using namespace std;
#include "unzip.h"
//---------------------------------------------------------------------------
#ifdef __BORLANDC__
#include <condefs.h>
USEUNIT("unzip.cpp");
USERC("avs-installer.rc");
#endif
//---------------------------------------------------------------------------
HINSTANCE hInstance;



// AvsInstaller -- this program unzips the zip file stored in RCDATA/1,
// and copies it into whichever of the winamp2/winamp3 directories were chosen.
// by Lucian Wischik - www.wischik.com/lu/programmer


void EnsureDirectories(const char *dir, const char *pos=0)
{ if (pos==0) pos=dir;
  const char *slash = strchr(pos,'\\');
  bool atend = (slash==0);
  if (atend) slash=pos+strlen(pos);
  char s[MAX_PATH]; strncpy(s,dir,slash-dir); *(s+(slash-dir))=0;
  if (GetFileAttributes(s)==0xFFFFFFFF)
  { CreateDirectory(s,0);
  }
  if (!atend) EnsureDirectories(dir,slash+1);
}

bool Install(HWND hwnd, const char *path2, const char *path3)
{ const char *paths[2]; paths[0]=path2; paths[1]=path3;
  HRSRC hrsrc = FindResource(NULL,MAKEINTRESOURCE(1),RT_RCDATA); if (hrsrc==NULL) {MessageBox(hwnd,"Payload not present","Error",MB_OK);return false;}
  DWORD size = SizeofResource(NULL,hrsrc);
  HGLOBAL hglob = LoadResource(NULL,hrsrc);  if (hglob==NULL) {MessageBox(hwnd,"Couldn't find payload","Error",MB_OK);return false;}
  void *buf = LockResource(hglob); if (buf==NULL) {MessageBox(hwnd,"Couldn't lock payload","Error",MB_OK);return false;}
  HZIP hz = OpenZip(buf,size,ZIP_MEMORY); if (hz==NULL) {MessageBox(hwnd,"Couldn't figure out payload","Error",MB_OK);return false;}
  ZIPENTRY ze; ZRESULT zres=GetZipItem(hz,-1,&ze); if (zres!=ZR_OK) {CloseZip(hz);MessageBox(hwnd,"Payload malformed","Error",MB_OK);return false;}
  int numentries=ze.index; if (numentries<=0) {CloseZip(hz);MessageBox(hwnd,"Empty payload","Error",MB_OK);return false;}

  for (int i=0; i<numentries; i++)
  { //PumpMessages();
    zres=GetZipItem(hz,i,&ze); if (zres!=ZR_OK) {MessageBox(hwnd,"Part of payload is faulty","Error",MB_OK); break;}

    // filename_inzip="path\file.scr", fn=path2 + "\path\file.scr"
    for (int n=0; n<2; n++)
    { if (paths[n][0]==0) continue;
      char fn[MAX_PATH];
      wsprintf(fn,"%s\\%s",paths[n],ze.name);
      char *c=fn; while (*c!=0) {if (*c=='/') *c='\\'; c++;}
      char dir[MAX_PATH]; strcpy(dir,fn); *(strrchr(dir,'\\'))=0;
      EnsureDirectories(dir);
      if ((ze.attr&FILE_ATTRIBUTE_DIRECTORY)==0)
      { if (GetFileAttributes(fn)!=0xFFFFFFFF)
        { SetFileAttributes(fn,FILE_ATTRIBUTE_NORMAL);
          DeleteFile(fn); // delete the old one if it was there
        }
        zres=UnzipItem(hz,i,fn,0,ZIP_FILENAME);
        if (zres!=ZR_OK) {MessageBox(hwnd,"Failure unzipping part of payload","Error",MB_OK); break;}
      }
    }
  }
  CloseZip(hz);
  return true;
}


INT CALLBACK BrowseCallbackProc(HWND hwnd,UINT msg,LPARAM,LPARAM data)
{ if (msg==BFFM_INITIALIZED)
  { SendMessage(hwnd,BFFM_SETSELECTION,TRUE,data);
  }
  return 0;
}

BOOL CALLBACK DialogProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM)
{ switch (msg)
  { case WM_INITDIALOG:
    { char path2[MAX_PATH]={0}, path3[MAX_PATH]={0};
      LONG res; HKEY key; DWORD size;
      res=RegOpenKeyEx(HKEY_LOCAL_MACHINE,"Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\Winamp",0,KEY_READ,&key);
      if (res==ERROR_SUCCESS)
      { size=MAX_PATH; RegQueryValueEx(key,"UninstallString",0,0,(LPBYTE)path2,&size);
        RegCloseKey(key);
      }
      res=RegOpenKeyEx(HKEY_LOCAL_MACHINE,"Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\Winamp3",0,KEY_READ,&key);
      if (res==ERROR_SUCCESS)
      { size=MAX_PATH; RegQueryValueEx(key,"UninstallString",0,0,(LPBYTE)path3,&size);
        RegCloseKey(key);
      }
      if (*path2!=0)
      { char *c=path2; if (*c=='"') c++;
        char *d=strrchr(c,'\\'); if (d!=0) strcpy(d,"\\Plugins\\avs");
        if (*path2!=0 && GetFileAttributes(path2)==0xFFFFFFFF) *path2=0;
        SetDlgItemText(hwnd,102,c);
        CheckDlgButton(hwnd,101, BST_CHECKED);
      }
      if (*path3!=0)
      { char *c=path3; if (*c=='"') c++;
        char *d=strrchr(c,'\\'); if (d!=0) strcpy(d,"\\Wacs\\data\\avs");
        if (*path3!=0 && GetFileAttributes(path3)==0xFFFFFFFF) *path3=0;
        SetDlgItemText(hwnd,105,c);
        CheckDlgButton(hwnd,104, BST_CHECKED);
      }
      SendMessage(hwnd,WM_APP,0,0);
    } return TRUE;
    case WM_APP:
    { BOOL ok=FALSE;
      if (IsDlgButtonChecked(hwnd,101)==BST_CHECKED) ok=TRUE;
      if (IsDlgButtonChecked(hwnd,104)==BST_CHECKED) ok=TRUE;
      EnableWindow(GetDlgItem(hwnd,IDOK),ok);
    } return TRUE;
    case WM_COMMAND:
    { int id=LOWORD(wParam), code=HIWORD(wParam);
      if ((id==102 || id==105) && code==EN_UPDATE)
      { char path[MAX_PATH]; GetDlgItemText(hwnd,id,path,MAX_PATH);
        CheckDlgButton(hwnd,id-1, (*path==0)?BST_UNCHECKED:BST_CHECKED);
        SendMessage(hwnd,WM_APP,0,0);
      }
      else if (id==101 || id==104) SendMessage(hwnd,WM_APP,0,0);
      if (id==103 || id==106)
      { char path[MAX_PATH]; GetDlgItemText(hwnd,id-1,path,MAX_PATH);
        BROWSEINFO bi; ZeroMemory(&bi,sizeof(bi));
        bi.hwndOwner=hwnd; bi.pszDisplayName=path;
        bi.lParam=(LPARAM)path; bi.lpfn=BrowseCallbackProc;
        bi.ulFlags=BIF_NEWDIALOGSTYLE|BIF_RETURNONLYFSDIRS;
        ITEMIDLIST *pidl = SHBrowseForFolder(&bi);
        if (pidl!=0)
        { SHGetPathFromIDList(pidl,path);
          SetDlgItemText(hwnd,id-1,path);
          LPMALLOC ialloc; SHGetMalloc(&ialloc); ialloc->Free(pidl); ialloc->Release();
        }
      }
      else if (id==IDCANCEL) EndDialog(hwnd,IDCANCEL);
      else if (id==IDOK)
      { char path2[MAX_PATH], path3[MAX_PATH];
        GetDlgItemText(hwnd,102,path2,MAX_PATH); GetDlgItemText(hwnd,105,path3,MAX_PATH);
        if (IsDlgButtonChecked(hwnd,101)!=BST_CHECKED) *path2=0;
        if (IsDlgButtonChecked(hwnd,104)!=BST_CHECKED) *path3=0;
        int iderr=0;
        if (*path2!=0 && GetFileAttributes(path2)==0xFFFFFFFF) iderr=102;
        if (*path3!=0 && GetFileAttributes(path3)==0xFFFFFFFF) iderr=105;
        if (iderr!=0)
        { SetFocus(GetDlgItem(hwnd,iderr));
          SendDlgItemMessage(hwnd,iderr,EM_SETSEL,0,-1);
          MessageBox(hwnd,"Incorrect path","AVS Installer",MB_OK);
          return TRUE;
        }
        SetCursor(LoadCursor(NULL,IDC_WAIT));
        bool ok = Install(hwnd,path2,path3);
        SetCursor(LoadCursor(NULL,IDC_ARROW));
        if (ok) MessageBox(hwnd,"Installed!","AVS Installer",MB_OK);
        EndDialog(hwnd,IDOK);
      }
    } return TRUE;
  }
  return FALSE;
}
 


WINAPI WinMain(HINSTANCE h,HINSTANCE,LPSTR,int)
{ hInstance=h;
  CoInitialize(0);
  DialogBox(hInstance,MAKEINTRESOURCE(101),0,DialogProc);
  CoUninitialize();
  return 0;
}

